function recalc_highpass
%
%
%

%Set the maximum frequency
load fs;
h=findobj('Tag','highpass_maxf');
set(h,'String',num2str(fs/2));

%Get the filter method
h=findobj('Tag','highpass_type');
v=get(h,'Value');

%Get the order of the filter
h=findobj('Tag','highpass_order');
s=get(h,'String');                                                                   
o=str2num(s);

%Get Fpass
h=findobj('Tag','highpass_fpass');
s=get(h,'String');                                                                   
fpass=str2num(s);

%Get Fstop
h=findobj('Tag','highpass_fstop');
s=get(h,'String');                                                                   
fstop=str2num(s);

%Is there any problem?
if ((fstop>=fpass)|(fstop<=0)|(fpass>=fs/2)),
   er;
   return;
end

%Get Wpass
h=findobj('Tag','wp');
s=get(h,'String');                                                                   
Wp=str2num(s);

%Get Wstop
h=findobj('Tag','ws');
s=get(h,'String');                                                                   
Ws=str2num(s);

% Calculate the filter according to the selection
if (v==1),
   b=remez(o,[0 2*fstop/fs 2*fpass/fs 1],[0 0 1 1],[Ws Wp]);
   a=1;
elseif (v==2),
   b=firls(o,[0 2*fstop/fs 2*fpass/fs 1],[0 0 1 1],[Ws Wp]);
   a=1;
elseif (v==3),
   b = fir2(o,[0 2*fstop/fs 2*fpass/fs 1],[0 0 1 1],kaiser(o+1,4));
   a=1;
elseif (v==4),
   [b,a]=cheby1(o,Wp,2*fpass/fs,'high');
   [z,p,k]=cheby1(o,Wp,2*fpass/fs,'high');
   figure;
   hold on;
   ezplot('x^2+y^2-1=0');
   title(' ');
   plot(real(p),imag(p),'x');   
elseif (v==5),
   [b,a]=cheby2(o,Wp,2*fpass/fs,'high');
   [z,p,k]=cheby2(o,Wp,2*fpass/fs,'high');
   figure;
   hold on;
   ezplot('x^2+y^2-1=0');
   title('Poles of the filter');
   plot(real(p),imag(p),'x');
   xlabel('REAL');
   ylabel('IMAGINARY');
elseif (v==6),
   [b,a]=ellip(o,Wp,Ws,2*fpass/fs,'high');
   [z,p,k]=ellip(o,Wp,Ws,2*fpass/fs,'high');
   figure;
   hold on;
   ezplot('x^2+y^2-1=0');
   title('Poles of the filter');
   plot(real(p),imag(p),'x');
   xlabel('REAL');
   ylabel('IMAGINARY');
elseif (v==7),
   [b,a]=butter(o,2*fpass/fs,'high');
   [z,p,k]=butter(o,2*fpass/fs,'high');
   figure;
   hold on;
   ezplot('x^2+y^2-1=0');
   title('Poles of the filter');
   plot(real(p),imag(p),'x');
   xlabel('REAL');
   ylabel('IMAGINARY');
end

% Draw the frequency response
[H,F] = freqz(b,a,128,'whole',fs);
ha=findobj('Tag','highpass_freq_line');
set(ha,'Xdata',linspace(-fs/2,fs/2,128),'Ydata',fftshift(abs(H)));

%Draw the group delay
[G,F]=grpdelay(b,a,128,'whole');
hb=findobj('Tag','highpass_groupdelay_line');
if (v<4),
   h=findobj('Tag','GDAXES');
   set(h,'YLim',[G(1)-1 G(1)+1]);
else
   h=findobj('Tag','GDAXES');
   set(h,'YLim',[min(G) max(G)]);
end

set(hb,'Xdata',linspace(-fs/2,fs/2,128),'Ydata',fftshift(G));

% Save the filter polynomials into some 'UserData'
set(ha,'Userdata',a);
set(hb,'Userdata',b);