function recalc_input_window
%
% Recalculate the input window according to the
% user settings

%Read the Sampling Frequency                                                                        
the_box=findobj('Tag','FS');                                                                        
the_string=get(the_box,'String');                                                                   
Fs=sscanf(the_string,'%f');                                                                         
                                                                                                    
%Read the real sine pulse frequency                                                                      
the_box=findobj('Tag','RS');                                                                        
the_string=get(the_box,'String');                                                                   
FR=sscanf(the_string,'%f');                                                                          

%Read the noised sine pulse frequency                                                                      
the_box=findobj('Tag','NS');                                                                        
the_string=get(the_box,'String');                                                                   
FN=sscanf(the_string,'%f');                                                                          

% Update the figure according to the radiobutton selected
the_button=findobj('Tag','RBM');                                                                  
VM=get(the_button,'Value');    
the_button=findobj('Tag','RBR');
VR=get(the_button,'Value');    
the_button=findobj('Tag','RBN');                                                                  
VN=get(the_button,'Value');    

% Get the handles of the plots
the_time_line=findobj('Tag','INTIME');
the_freq_line=findobj('Tag','INFREQ');   

if (VM==1),
   data=get(the_time_line,'Ydata');
   t=linspace(0,size(data,2)/Fs,size(data,2));
   set(the_time_line,'Xdata',t,'Ydata',data);
   
   set(the_freq_line,'Xdata',linspace(-Fs/2,Fs/2,size(t,2)),'Ydata',fftshift(abs(fft(data))));
elseif (VR==1),
   t=[0:1/Fs:2*pi];
   set(the_time_line,'Xdata',t,'Ydata',sin(2*pi*FR*t));
   
   set(the_freq_line,'Xdata',linspace(-Fs/2,Fs/2,size(t,2)),'Ydata',fftshift(abs(fft(sin(2*pi*FR*t)))));
elseif (VN==1),
   t=[0:1/Fs:2*pi];
   set(the_time_line,'Xdata',t,'Ydata',sin(2*pi*FN*t)+0.3*randn(1,size(t,2)));
   
   set(the_freq_line,'Xdata',linspace(-Fs/2,Fs/2,size(t,2)),'Ydata',fftshift(abs(fft(sin(2*pi*FN*t)++0.1*rand(1,size(t,2))))));
end

% Fix axes widths
h=findobj('Tag','Axes7');
set(h,'XLim',[0 max(t)]);

h=findobj('Tag','Axes8');
set(h,'XLim',[-Fs/2 Fs/2]);


                                                                                                    
