function recalc_main_window
%
% Recalculates the graphs of the main window
%
%

% Load the sampling frequency used throughout the script
load fs;

% Load the input signal saved in 'input.mat'
load input;
% Draw the input signal in time
h=findobj('Tag','main_input_line');
set(h,'Xdata',linspace(0,size(in,2)/fs,size(in,2)),'Ydata',in);
h=findobj('Tag','Axes1');
set(h,'XLim',[0 size(in,2)/fs]);

% Draw the input signal in the frequency domain
h=findobj('Tag','main_input_freq_line');
set(h,'Xdata',linspace(-fs/2,fs/2,size(in,2)),'Ydata',fftshift(abs(fft(in))));
h=findobj('Tag','Axes4');
set(h,'XLim',[-fs/2 fs/2]);

% Load the filter polynomial(s)
load filter;
[H,W]=freqz(b,a,256,'whole');

% Plot the impulse response of the filter
h=findobj('Tag','main_filter_line');
set(h,'Xdata',linspace(0,size(H,1)/fs,size(H,1)),'Ydata',ifft(H));
h=findobj('Tag','Axes2');
set(h,'XLim',[0 size(H,1)/fs]);


% Plot the frequency responce of the filter
[H,W]=freqz(b,a,256,'whole');
h=findobj('Tag','main_filter_freq_line');
set(h,'Xdata',linspace(-fs/2,fs/2,size(H,1)),'Ydata',fftshift(abs(H)));
h=findobj('Tag','Axes5');
set(h,'XLim',[-fs/2 fs/2]);

% Plot the output signal in time
h=findobj('Tag','main_output_line');
y=filter(b,a,in);
set(h,'Xdata',linspace(0,size(y,2)/fs,size(y,2)),'Ydata',y);
h=findobj('Tag','Axes3');
set(h,'XLim',[0 size(y,2)/fs]);

% plot the output signal's spectra
h=findobj('Tag','main_output_freq_line');
set(h,'Xdata',linspace(-fs/2,fs/2,size(in,2)),'Ydata',fftshift(abs(fft(y))));
h=findobj('Tag','Axes6');
set(h,'XLim',[-fs/2 fs/2]);

